﻿using System.Collections.Generic;

namespace Tactile
{
    public class Event_Control_Names
    {
        public readonly static Dictionary<int, string> CONTROLS = new Dictionary<int, string> 
        {
            {   1, "Prep Message" },
            {   2, "Run Message" },
            {   3, "Wait" },
            {   4, "Change Chapter" },
            {   5, "Change Screen Tone" },
            {   6, "Warp Cursor" },
            {   7, "Close Message" },
            {   8, "Follow Moving Unit" },

            {  10, "Warp Unit" },
            {  11, "Move Unit" },
            {  12, "Wait for Move" },
            {  13, "Chapter Change Effect" },
            {  14, "Add Battle Convo" },
            {  15, "Temp Death Quote" },
            {  16, "Change Gold" },
            {  17, "Set Screen Color" },
            {  18, "Show Popup" },
            {  19, "Show Gold Gain Popup" },
            {  20, "Unit Battle Theme" },
            {  21, "Add Unit" },
            {  22, "Change Mission" },
            {  23, "Change Team" },
            {  24, "Change Group" },
            {  25, "Change Team Name" },
            {  26, "Set Boss" },
            {  27, "Set Drops" },
            {  28, "Add Talk Event" },
            {  29, "Add Deployment Point" },
            {  30, "Add/remove to Battalion" },
            // Map Settings
            {  31, "Target Tile" },
            {  32, "Force Deployment" },
            {  33, "Set Convoy" },
            {  34, "Convoy Item Gain" },
            {  35, "Remove Unit" },
            {  36, "Remove Talk Event" },
            {  37, "Set FoW" },
            {  38, "Set FoW Vision" },
            {  39, "Set Weather" },
            {  40, "FoW Light Source" },
            // Map Settings
            {  41, "Change Tile" },
            {  42, "Pillage Tile" },
            {  43, "Add Area Background" },
            {  44, "Add Destroyable Object" },
            {  45, "Import Map Area" },
            {  46, "Add Siege Engine" },
            {  47, "Edit Tile Outlines" },
            {  48, "AI Target Map Object" },
            // Actors
            {  51, "Change Class" },
            {  52, "Exp Gain" },
            {  53, "Item Gain" },
            {  54, "Discard Item" },
            {  55, "WExp Gain" },
            {  56, "Support" },
            {  57, "Boss Hard Mode Stats" },
            {  58, "Block Support" },
            {  59, "Change Status" },
            // Various
            {  61, "Heal Actors" },
            {  62, "Set Unit Ready" },
            {  63, "Set Map Edge Offsets" },
            {  64, "Unload Actor" },
            {  65, "Rescue" },
            {  66, "Change Actor Name" },
            // Alpha
            {  71, "Set Min Alpha" },
            {  72, "Refresh Alpha" },
            {  73, "Add Alpha Source" },
            {  74, "Clear Alpha Sources" },
            {  75, "Set Ally Alpha" },
            {  76, "Blacken Screen" },
            // Shops
            {  81, "Add Visit Location" },
            {  82, "Close Visit Location" },
            {  83, "Add Shop Location" },
            {  84, "Shop Text" },
            {  85, "Shop Inventory" },
            {  86, "Add Arena Location" },
            // Objectives
            {  91, "Add Escape Point" },
            {  92, "Add Seize Point" },
            {  93, "Add Defend Area" },
            {  94, "Add Unit Seek Location" },
            {  95, "Add Team Seek Location" },
            {  96, "Change Objective" },
            {  97, "Set Team Leader" },
            {  98, "Loss On Death" },
            // Debug
            { 101, "Debug Print" },
            { 102, "Comment" },
            { 103, "ASMC" },
            { 104, "Deprecated" },
            // Switches/Variables
            { 111, "Set Switch" },
            { 112, "Set Variable" },
            { 113, "Dialogue Prompt" },
            { 114, "Confirmation Prompt" },
            // Scene Controls
            { 121, "Return to Title" },
            { 122, "Game Over" },
            { 123, "Return to World Map" },
            { 124, "Preparations" },
            { 125, "Map Save" },
            { 126, "End Chapter" },
            { 127, "Home Base" },
            { 128, "Wait for Preparations" },
            { 129, "Add Base Event" },
            { 130, "Gain Completion Points" },
            // Audio
            { 131, "Play BGM" },
            { 132, "Fade BGM" },
            { 133, "Play SFX" },
            { 134, "Play BGS" },
            { 135, "Stop BGS" },
            { 136, "Fade SFX" },
            { 137, "Stop SFX" },
            { 138, "Duck BGM" },
            // World Map
            { 141, "Center Worldmap Camera" },
            { 142, "Worldmap Dot" },
            { 143, "Worldmap Arrow" },
            { 144, "Worldmap Remove Dot" },
            { 145, "Worldmap Beacon" },
            { 146, "Worldmap Remove Beacon" },
            { 147, "Wmap Zoomed Out" },
            { 151, "Worldmap Unit" },
            { 152, "Wmap Queue Unit Move" },
            { 153, "Wmap Queue Unit Idle" },
            { 154, "Wmap Queue Unit Pose" },
            { 155, "Wmap Queue Unit Remove" },
            { 156, "Wmap Clear Removing" },
            { 157, "Wmap Queue Track Unit" },
            { 158, "Wmap Wait for Units" },
            // Scripted Battles
            { 171, "Preset RNs" },
            { 172, "Scripted Battle" },
            { 173, "Scripted Battle Params" },
            // If/Else
            { 201, "If statement" },
            { 202, "If statement (or)" },
            { 203, "Else statement" },
            { 204, "EndIf statement" },
            { 205, "ElseIf statement" },
            // Skip
            { 211, "Skip block start" },
            { 212, "Skip block if skipped" },
            { 213, "Skip block end" },
            { 214, "Skip override start" },
            { 215, "Skip override end" },
            { 216, "Skip cancel" },
            // Loop
            { 221, "Loop start" },
            { 222, "Loop end" },
            { 223, "Loop break" },
            { 224, "Loop next" },
            // Events
            { 250, "Delete Event" },
            { 251, "Cancel Other Events" },
            { 252, "Call Event" },
        };
    }
}
